#
# test01.rb
# testing the new most
# by pts@fazekas.hu at Thu Dec 14 14:22:48 CET 2000
# >120 tests
#
require "pts_tester"

test_options ARGV
# ^^^ `-v' to be verbose
# ^^^ `-v -v' to be very verbose

test_group "testsuite" do
  test_eq "alma", "alma"
  test_eq 98765**5, 9397565044995155856228125
  test_ex(SyntaxError) { raise SyntaxError }
  test_ex(SystemCallError) do
    begin
      raise LoadError
      test_ok false
    rescue LoadError
      test_ok true
    end
    raise SystemCallError
  end
end

test_group "trace" do
  require "flex"
  # vvv formerly test01.rb
  test_exx(FlexRuntimeLineError,/^premature EOF/) do Flex.trace("","") end
  test_exx(FlexRuntimeLineError,/^bad character: %/) do Flex.trace("%","") end
  f=Flex.trace("%%","")
  test_exx(FlexRuntimeUsageError,/^unknown option/) do Flex.trace("%%","-z") end
  # </>
  test_ex(FlexWarning) do f=Flex.new(["-W",nil,"alma"]) end
end

test_group "printbuf" do
  # vvv formerly test04.rb
  # testing Printbuf
  # by pts@fazekas.hu at Sun Dec 10 11:32:23 CET 2000
  require "flex"
  # b=Flex::Printbuf.new
  # p Flex.methods
  # p Flex.constants
  # b << "alma"; b << "krte"; p b

  b=Flex::Printbuf.new
  test_is ((b << "a"),			"a")
  k=100000
  (1..k).each do b << "b" end
  test_is ((b << " pts rulez!").type,	Flex::Printbuf)
  b.printf "%04d",42
  test_is b.length,			100016
  test_is b.alloced,			131072
  test_is b.pos=k-30,			 99970
  c=b.clone
  test_is b.forget(k-40),		nil
  test_is b.length,			56
  test_is b.alloced,			128
  # Imp: test, implement b.pop, b.shift, b.clone, b.freeze etc.
  # test_ex(NotImplementedError) do b.clone end
  test_is b.pos,			10
  test_is c.length,			100016
  test_is c.alloced,			131072
  test_is c.forget(k-20),		nil
  test_is c.forget_last(2),		nil
  test_is c << c,			"bbbbbbbbbbbbbbbbbbbbb pts rulez!00bbbbbbbbbbbbbbbbbbbbb pts rulez!00"
  test_is c.length,			68
  test_is c.alloced,			128
  test_is c.freeze,			c
  test_is c,				"bbbbbbbbbbbbbbbbbbbbb pts rulez!00bbbbbbbbbbbbbbbbbbbbb pts rulez!00"
  test_exx(TypeError,/^can't modify frozen /) do c.printf("%c",42) end
  d=c.clone
  test_is d,				c
  test_exx(TypeError,/^can't modify frozen /) do d.printf("%c",422) end
end

test_group "go/clone" do
  # vvv formerly test02.rb
  # by pts@fazekas.hu at Sun Dec 10 02:33:06 CET 2000
  # -- Sun Dec 10 10:57:08 CET 2000
  require "flex"
  # ar=[nil,nil,"al [mv]a"]; f=Flex.new(ar)
  # f=Flex.new("al [mv]aa*"); # :2 all..
  f=Flex.new("al [mv]ab*");
  test_exx(NameError, /^private method /) do f.get_ct end
  test_is f.go("al ma"),		2
  GC.start
  test_is f.go("al ma"),		1
  f.reset
  test_is f.go("al ma"),		2
  GC.start
  g=f.clone
  test_is g.go("al ma"),		1
  g.reset
  test_is g.go("al ma"),		2
  test_is f.go("al ma"),		1
  test_is f =~ "alva",			false
  test_is g =~ "al",			false
  test_is f =~ "al va",			2
  test_is f =~ "al vajaro",		false
  # test_is f =~ "al vajaro",		2 # (was strange !)

  # vvv formerly test03.rb
  # by pts@fazekas.hu at Sun Dec 10 11:32:23 CET 2000
  # require "flex"
  f=Flex.new( [nil, nil, "al[vm]a", "bar"] );
  # ^^^ we have given 2 regexps with indices 2 and 3
  f.reset				# we're starting from the beginning
  test_is f.go("ba"),			0 # ("ba" is a partial match -- more chars are needed)
  test_is f.go("r"),			3 # ("bar" matches regexp 3)
  test_is f.go("xy"),			1 # ("barxy" is hopeless)
  f.reset
  test_is f.go("al"),			0
  g=f.clone
  test_is f.go("ma"), 			2 # ("alma" matches regexp 2)
  test_is g.go("va"),			2 # ("alva" matches regexp 2)
end

test_group "go/opts" do
  require "flex"
  f=Flex.new([nil,nil,"al[mv]a","al"]);
  # Imp: test for `n'
  test_exx(FlexRuntimeError,/^extra is /) do f.extra end
  f.opts|=Flex::OPT_EXTRA
  test_is f.extra,			""
  test_is f.go("al"),			3
  test_is f.extra,			""
  test_is f.go("va"),			2
  test_is f.extra,			""
  test_is f.go("alma"),			1
  test_is f.go("anything"),		1
  # f.opts=Flex.;
  test_is((f.opts=Flex::OPT_RESET|Flex::OPT_REMEMBER|Flex::OPT_EXTRA), 28)
  test_is f.opts,			28
  test_is f.go("alma"),			3
  test_is f.extra,			"al"
  test_is f.go("al"),			3
  test_is f.extra,			"al"
  test_is((f.opts&=~Flex::OPT_RESET), 24)
  test_is f.go("ma"),			2
  test_is f.extra,			"ma" # !! (but "alma" matched)
end

test_group "go/start-condition" do
  # by pts@fazekas.hu at Sun Dec 17 13:35:07 CET 2000
  # testing multiple start conditions
  require "flex"
  test_exx(FlexRuntimeLineError,/^undeclared start condition ALMA /) do
    f=Flex.new([nil,nil,
      '<ALMA>alma',
      '<KORTE>korte',
    ]);
  end
  test_exx(NameError,/^undefined local variable /) do  
    f.opts=Flex::OPT_REMEMBER|Flex::OPT_EXTRA
  end
  test_exx(FlexRuntimeLineError,/^undeclared start condition KORTE /) do
    f=Flex.new([nil,'%x ALMA',
      '<ALMA>alma',
      '<KORTE>korte',
    ]);
  end
  test_exx(FlexRuntimeLineError,/^start condition INITIAL declared twice /) do
    f=Flex.new([nil,'%x INITIAL',
      '<ALMA>alma',
      '<KORTE>korte',
    ]);
  end
  f=Flex.new([nil,"%x ALMA\n%s KORTE",
    'fa',
    '<ALMA,INITIAL>alma',
    '<KORTE>korte',
  ]);
  test_is f.yystart,				"INITIAL"
  test_is f =~ "fa",				2
  test_is f =~ "alma",				3
  test_is f =~ "korte",				false
  test_is f =~ "fafa",				false
  test_is f =~ "almafa",			false
  test_is f =~ "f",				false
  test_is f =~ "al",				false
  test_exx(FlexRuntimeError,/^unknown start condition /) do f.begin("AL"); end
  test_is f.begin("ALMA"),			"ALMA"
  test_is f =~ "fa",				false
  test_is f =~ "alma",				3
  test_is f =~ "korte",				false
  test_is f.yystart="KORTE",			"KORTE"
  test_is f =~ "fa",				2
  test_is f =~ "alma",				false
  test_is f =~ "korte",				4
end

test_group "most/foos" do
  require "flex"
  f=Flex.new([nil,nil,'foo*','foobar'])
  f.opts |= Flex::OPT_REMEMBER
  f.reset
  test_is f.most("fo"),			0
  test_is f.most("o"),			0
  g=f.clone;
  test_is g.most("o"),			0
  test_is g.most(false),		2
  test_is g.yytext,			"fooo"
  g=f.clone
  test_is g.most("bar"),		3
  test_is g.yytext,			"foobar"
  g=f.clone
  test_is g.most("z"),			2
  test_is g.yytext,			"foo"
  test_is g.ahead,			"z"
  test_is f.most("b"),			0
  g=f.clone
  test_is g.most("i"),			2
  test_is g.yytext,			"foo"
  test_is g.ahead,			"bi"
  g=f.clone
  test_is g.most("ar"),			3
  test_is g.yytext,			"foobar"
  test_is g.most("fo"),			0
  test_is g.most(false),		2
  test_is g.yytext,			"fo"
end

test_group "most/remember" do
  require "flex"
  f=Flex.new([nil,nil,"al[vm]a","al","gb"]);
  f.opts=Flex::OPT_REMEMBER|Flex::OPT_EXTRA;  def emp(s); s; end
  # f.opts=0; def emp(s); ""; end
  test_is f.most(""),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			""
  test_is f.most(""),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			""
  test_is f.most("a"),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			"a"
  test_is f.most(""),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			"a"
  test_is f.most("l"),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_exx(FlexRuntimeError,/^partial match/) do f.yytext end
  test_is f.ahead,			"al"

  g=f.clone
  test_is g.most("gb"),			3
  test_is g.ahead,			"gb"
  test_is g.yytext,			emp("al")

  test_is f.most("al"),			3
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			"al"  # "al"
  test_is f.yytext,			emp("al")

  test_is f.most(""),			0
  # ^^^ yytext() is removed
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			"al"
  test_is f.most("m"),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			"alm"

  # vvv These tests are absolete now, since we have no-way-to-make-longer
  #     optimisation in flex_most()
  # test_is f.most("a"),			0
  # test_eq f.extra, f.ahead, f.extra.pre
  # test_is f.ahead,			"alma"
  # test_is f.most(nil),			0
  # test_eq f.extra, f.ahead, f.extra.pre
  # test_is f.ahead,			"alma"
  # test_is f.most(false),		2
  # # ^^^ signal EOF -- demand last match

  test_eq f.most("a"),			2
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			""
  test_is f.yytext,			emp("alma")
  test_is f.most(false),		0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			""
  test_is f.nchars,			6

  g=f.clone
  test_is g.most("alv"),		0
  test_eq g.extra, g.ahead, g.extra.pre
  test_is g.ahead,			"alv"
  test_is g.most("axe"),		2
  test_eq g.yytext, g.extra.pre
  test_eq g.yytext+g.ahead, g.extra
  test_is g.ahead,			"xe"
  test_is g.yytext,			emp("alva")
  test_is g.nchars,			10

  test_is f.most("g"),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			"g"
  test_is f.most("bxyp"),		4
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			"xyp"
  test_is f.yytext,			emp("gb")
  test_is f.most("lex"),		1
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			""
  test_is f.yytext,			emp("x")
  test_ex(FlexRuntimeError) do f.most "alma" end
  # ^^^ cannot continue failed match...
  test_ex(FlexRuntimeError) do f.most "bad" end
  # ^^^ cannot continue failed match...
  test_ex(FlexRuntimeError) do f.most "" end
  # ^^^ cannot continue failed match...
  test_is f.reset,			nil
  test_is f.most("albion"),		3
  # ^^^ we can continue after reset
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			"bion" # "albion"
  test_is f.yytext,			emp("al")
  test_is f.most(nil),			1
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			"" # "b"
  test_is f.yytext,			emp("b")
  test_ex(FlexRuntimeError) do f.most "" end
  test_is f.reset,			nil
  test_is f.most(""),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			""
  test_is f.nchars,			12
end

test_group "most/dont-remember" do
  require "flex"
  f=Flex.new([nil,nil,"al[vm]a","al","gb"]);
  # f.opts=Flex::OPT_REMEMBER|Flex::OPT_EXTRA;  def emp(s); s; end
  f.opts=Flex::OPT_EXTRA; def emp(s); ""; end
  test_is f.most(""),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			""
  test_is f.most(""),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			""
  test_is f.most("a"),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			"a"
  test_is f.most(""),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			"a"
  test_is f.most("l"),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_exx(FlexRuntimeError,/^partial match/) do f.yytext end
  test_is f.ahead,			"al"

  g=f.clone
  test_is g.most("gb"),			3
  test_is g.ahead,			"gb"
  test_is g.yytext,			emp("al")

  test_is f.most("al"),			3
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			"al"  # "al"
  test_is f.yytext,			emp("al")

  test_is f.most(""),			0
  # ^^^ yytext() is removed
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			"al"
  test_is f.most("m"),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			"alm"

  # vvv These tests are absolete now, since we have no-way-to-make-longer
  #     optimisation in flex_most()
  # test_is f.most("a"),			0
  # test_eq f.extra, f.ahead, f.extra.pre
  # test_is f.ahead,			"alma"
  # test_is f.most(nil),			0
  # test_eq f.extra, f.ahead, f.extra.pre
  # test_is f.ahead,			"alma"
  # test_is f.most(false),		2
  # # ^^^ signal EOF -- demand last match

  test_eq f.most("a"),			2
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			""
  test_is f.yytext,			emp("alma")
  test_is f.most(false),		0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			""
  test_is f.nchars,			6

  g=f.clone
  test_is g.most("alv"),		0
  test_eq g.extra, g.ahead, g.extra.pre
  test_is g.ahead,			"alv"
  test_is g.most("axe"),		2
  test_eq g.yytext, g.extra.pre
  test_eq g.yytext+g.ahead, g.extra
  test_is g.ahead,			"xe"
  test_is g.yytext,			emp("alva")
  test_is g.nchars,			10

  test_is f.most("g"),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			"g"
  test_is f.most("bxyp"),		4
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			"xyp"
  test_is f.yytext,			emp("gb")
  test_is f.most("lex"),		1
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			""
  test_is f.yytext,			emp("x")
  test_ex(FlexRuntimeError) do f.most "alma" end
  # ^^^ cannot continue failed match...
  test_ex(FlexRuntimeError) do f.most "bad" end
  # ^^^ cannot continue failed match...
  test_ex(FlexRuntimeError) do f.most "" end
  # ^^^ cannot continue failed match...
  test_is f.reset,			nil
  test_is f.most("albion"),		3
  # ^^^ we can continue after reset
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			"bion" # "albion"
  test_is f.yytext,			emp("al")
  test_is f.most(nil),			1
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			"" # "b"
  test_is f.yytext,			emp("b")
  test_ex(FlexRuntimeError) do f.most "" end
  test_is f.reset,			nil
  test_is f.most(""),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			""
  test_is f.nchars,			12
end

test_group "most/tokenizing" do
  require "flex"
  f=Flex.new([nil,nil,
    '[a-zA-Z_][a-zA-Z0-9]*',		# 2
    '\"[^\"]*\"',			# 3
    '\/\*[^\*]*\/',			# 4
    '.'					# 5
  ]);
  f.opts=Flex::OPT_REMEMBER|Flex::OPT_EXTRA
  test_is f.most("alma="),		2
  test_is f.yytext,			"alma"
  test_is f.most(""),			5
  test_is f.yytext,			"="
  test_is f.most(""),			0
  test_exx(FlexRuntimeError,/^partial match/) do f.yytext end
  test_is f.extra.pre,			""
  test_is f.most("9"),			5
  # test_is f.most(false),		5
  test_is f.yytext,			"9"
  test_exx(TypeError,/^no implicit conversion /) do f.nchars="a" end
  test_is f.nchars,			6
  test_is f.nchars=42,			42
  test_is f.nchars,			42
  test_is f.free,			nil
  test_exx(TypeError,/^cannot match with freed /) do f.most(false) end
  test_is f.free,			nil
  test_exx(TypeError,/^cannot match with freed /) do f.most(false) end

  # vvv There was another static variable in the flex sources (fixed at Sat Dec 16 19:42:39 CET 2000)
  f=Flex.new([nil,nil,
    '.*\n?'
  ]);
  f.opts=Flex::OPT_REMEMBER|Flex::OPT_EXTRA
  test_is f.most(""),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			""
  test_is f.most("ali"),		0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			"ali"
  test_is f.most("na"),			0
  test_eq f.extra, f.ahead, f.extra.pre
  test_is f.ahead,			"alina"
  test_is f.most("!\n\n"),		2
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			"\n"
  test_is f.yytext,			"alina!\n"
  test_is f.most("last"),		2
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			"last"
  test_is f.yytext,			"\n"
  test_is f.most(false),		2
  test_eq f.yytext, f.extra.pre
  test_eq f.yytext+f.ahead, f.extra
  test_is f.ahead,			""
  test_is f.yytext,			"last"
end

test_group "bug01" do
  # by pts@fazekas.hu at Tue May 15 19:31:36 CEST 2001
  # bug reported by Tanaka Akira
  re = Flex.new('@a*@')
  test_is re.most("@aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"), 0
  test_is re.most("a"), 0
  re = Flex.new('@a*@')
  test_is re.most("@aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"), 0
  test_is re.most(""), 0
end

test_group "bug02" do
  # by pts@fazekas.hu at Thu May 17 20:02:29 CEST 2001
  # bug reported by Tanaka Akira
  re = Flex.new([nil, nil, "a+"])
  re.opts |= Flex::OPT_REMEMBER
  test_is re.most('a' * 64 + ' '), 2
  test_is re.yytext, 'a'*64
end

test_done
